﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectMachine
{
    internal class DrawningObject : IDrawningObject
    {
        private DrawningMachine _machine = null;

        public DrawningObject(DrawningMachine machine)
        {
            _machine = machine;
        }

        public float Step => _machine?.Machine?.Step ?? 0;

        public (float Left, float Right, float Top, float Bottom) GetCurrentPosition()
        {
            return _machine?.GetCurrentPosition() ?? default;
        }

        public void MoveObject(Direction direction)
        {
            _machine?.MoveTransport(direction);
        }

        public void SetObject(int x, int y, int width, int height)
        {
            _machine.SetPosition(x, y, width, height);
        }

        void IDrawningObject.DrawningObject(Graphics g)
        {
            _machine.DrawTransport(g);
        }
    }
}
