﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectMachine
{
    /// <summary>
    /// Класс-сущность "Танк"
    /// </summary>
    internal class EntityTank : EntityMachine
    {
        /// <summary>
        /// Дополнительный цвет
        /// </summary>
        public Color DopColor { get; private set; }
        /// <summary>
        /// Признак наличия обвеса
        /// <summary>
        public bool BodyKit { get; private set; }
        /// <summary>
        /// Признак наличия башни с орудием
        /// </summary>
        public bool Turret { get; private set; }
        /// <summary>
        /// Признак наличия зенитного пулемета
        /// </summary>
        public bool Gun { get; private set; }
        /// <summary>
        /// Инициализация свойств
        /// </summary>
        /// <param name="speed">Скорость</param>
        /// <param name="weight">Вес автомобиля</param>
        /// <param name="bodyColor">Цвет кузова</param>
        /// <param name="dopColor">Дополнительный цвет</param>
        /// /// <param name="bodyKit">Признак наличия обвеса</param>
        /// <param name="turret">Признак наличия башни с орудием</param>
        /// <param name="gun">Признак наличия зенитного пулемета</param>
        public EntityTank(int speed, float weight, Color bodyColor, Color dopColor, bool bodyKit, bool turret, bool gun) :
            base(speed, weight, bodyColor)
        {
            DopColor = dopColor;
            BodyKit = bodyKit;
            Turret = turret;
            Gun = gun;
        }

    }
}
